<script>

  import { beforeUpdate, onMount } from 'svelte';

  import emojis from 'emoji.json/emoji-compact.json';

  export let setApp   = null;
  export let number   = '';
  export let contacts = [];
  export let messages = [];
  
  export let target = null;

  export let _contact  = null;

  let message        = '';
  let action         = null;
  let messageInputEl = null;

  let _contactLabel     = '';
  let _contactMessages = [];

  function onMessageInputKeyPress(e) {

    if(e.keyCode === 13) {
      if(e.ctrlKey)
        message += '\n';
      else
        sendMessage();
    }

  }

  function sendMessage() {
    window.parent.postMessage(JSON.stringify({action: 'send_message', to: target.toString(), message}))
    message = '';
  }

  beforeUpdate(() => {

    _contact = contacts.find(e => e.number === target);

    if(_contact)
      _contactLabel = `${_contact.name} #${_contact.number}`;
    else
      _contactLabel = `#${target}`;

    _contactMessages = messages.filter(e => e.from === target || e.to === target).slice(0).sort((a, b) => a.time - b.time);

  });

  onMount(() => {
    messageInputEl.scrollIntoView();
  });

</script>

<style>

  .hidden {
    display: none !important;
  }

  .scrollable::-webkit-scrollbar {
    width: 8px;
  }
  
  .scrollable::-webkit-scrollbar-thumb {
    background: #666;
  }

  .scrollable::-webkit-scrollbar-track {
    background: #ddd;
  }

  .app-messagethread {
    width: calc(100% - 16px);
    height: 100%;
    display: flex;
    flex-direction: column;
  }

  .contact {
    height: 32px;
    border-radius: 5px;
    background-color: rgba(255, 255, 255, 0.15);
    margin: 0 8px 8px 8px;
    color: #FFF;
    font-weight: bold;
    line-height: 32px;
    text-align: center;
  }
  
  .messages {
    display: flex;
    flex-direction: column;
    overflow-y: auto;
    padding-right: 8px;
  }

  .message {
    width: 80%;
    padding: 8px;
    border-radius: 8px;
    background-color: rgb(44, 44, 44);
    color: #bdbdbd;
  }

  .message:not(:first-child) {
    margin-top: 8px;
  }

  .message.in {
    border-radius: 0 8px 8px 8px;
  }

  .message.in:hover {
    background-color: rgb(54, 54, 54);
  }

  .message.out {
    background-color: rgb(27, 94, 196);
    align-self: flex-end;
    border-radius: 8px 8px 0 8px;
  }

  .message.out:hover {
    background-color: rgb(30, 107, 223)
  }


  textarea[name="message-input"] {
    width: calc(100% - 8px);
    height: 100px;
    border: 1px solid #ffffff2e;
    margin: 8px;
    background-color: #000000b8;
    color: #fff;
    resize: none;
  }

  textarea[name="message-input"]:focus {
    outline: none;
  }

  .message-actions {
    display: block;
    margin: 8px 0 8px 8px;
    background-color: rgba(100, 100, 100, 0.25);
    padding: 8px;
  }

  .message-actions .fas:hover {
    color: #FFF;
  }

  .message-action {
    width: 32px;
  }

  .emojis {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    flex-wrap: wrap;
    padding: 4px;
    background-color: rgba(0, 0, 0, 0.25);
  }

  .emoji {
    font-size: 2em;
  }

</style>

<div class="app-messagethread">

  <div class="contact">{_contactLabel}</div>

  <div class="messages scrollable">
    
    {#each _contactMessages as message}
      <div class="message {message.from === number ? 'out' : 'in'}">
        <div class="message-body">{message.body}</div>
      </div>
    {/each}

    <div class="message-actions">
      <div class="message-action" on:mouseup={e => {action === 'emoji' ? action = null : action = 'emoji'}}><li class="fas fa-grin-alt fa-2x"></li></div>
    </div>

    <div class="message-input-wrap">
      <textarea name="message-input" class="scrollable" bind:value={message} on:keyup={e => onMessageInputKeyPress(e)} bind:this={messageInputEl}></textarea>
    </div>

    <div class="emojis scrollable {action === 'emoji' ? '' : 'hidden'}">
      {#if action === 'emoji'}
        {#each emojis as emoji}
          <div class="emoji" on:mouseup={e => {message += emoji; action = null}}>{emoji}</div>
        {/each}
      {/if}
    </div>

  </div>

</div>